#####################################################
# E-Blah Bulliten Board Systems  -  Platinum Series #
#####################################################
# Copyright (c) 2001 - 2006 E-Blah.                 #
#####################################################

require("$language/Routines.lng");

{
	# DO NOT REMOVE OR EDIT THE FOLLOWING LINE (unless licensed) ... DOING SO IS AGAINST THE GPL LICENSE AGREEMENT
	$copyright = qq~Powered by <a href="http://www.eblah.com" target="_blank">E-Blah</a> $versioncr &#169; 2001-2006~;
	%botsearch = ('mediapartners-google<>'=>'AdSense','googlebot<>'=>'Googlebot','slurp<>'=>'Yahoo! Bot','msnbot<>'=>'MSN Bot','inktomi<>'=>'Hot Bot','ask jeeves<>'=>'AskJeeves.com','lycos<>'=>'Lycos','ia_archiver<>'=>'Archive.org'); # <> - makes it not open .dat files

	if($settings[1] eq '') { $settings[15] = $gtzone; }

	$date_time = get_date(time,1);

	my $oldtime = time-86400;
	($t,$t,$t,$Yday,$Ymonth,$Yyear) = gmtime($oldtime+(3600*($settings[15]+$settings[31]+$gtoff)));
	($t,$t,$Khour,$Kday,$Kmonth,$Kyear) = gmtime(time+(3600*($settings[15]+$settings[31]+$gtoff)));
	$Kyear += 1900;
	$Yyear += 1900;

	if($URL{'v'} eq 'checktime') { CheckTime(); }
}

sub header {
	my($sfoot,$Ecopyright,$sep);
	if($hdone) { return; } # Headers have already been completed
	$new = 0;

	if($ENV{'HTTP_ACCEPT_ENCODING'} !~ /gzip/ && $gzipen) { $gzipen = 0; } # Browser doesn't support gzip
	if($gzipen) { print "Content-Encoding: gzip\n"; }
	print "Content-type: text/html\n\n";

	$hdone = 1;

	# Time of day ...
	if($Khour > 11 && $Khour < 17)  { $wmessage = $rtxt[46]; } # Afternoon
	elsif($Khour <= 12 && $Khour > 2) { $wmessage = $rtxt[45]; } # Morning
		else { $wmessage = $rtxt[47]; } # Evening

	if($username eq 'Guest') {
		$userwelcome = $displayuser = qq~$rtxt[1], <b>$rtxt[2]</b>.~;
		$displayuser .= $userpm = qq~$rtxt[3] <a href="$surl\lv-login/">$rtxt[4]</a> $rtxt[44] <a href="$surl\lv-register/">$rtxt[5]</a>.~; ShowGuest(); }
	elsif($settings[1] eq '') {
		$userwelcome = $displayuser = qq~$rtxt[1] $rtxt[9] <b>$username</b>.~;
		$displayuser .= $userpm = $rtxt[7]; $settings[46] = 1;
	} else { $pmcnt = 0; $new = 0; $pmsent = 0; $pmstore = 0;
		fopen(FILE,"$members/$username.pm");
		while(<FILE>) {
			($med,$t,$t,$t,$t,$t,$n) = split(/\|/,$_);
			if($med == 1) {
				++$new if($n);
				++$pmcnt;
			} elsif($med == 2) { ++$pmsent; }
			elsif($med == 3) { ++$pmstore; }
				else { ++$pmcnt{$med}; }
		}
		fclose(FILE);
		$userwelcome = $displayuser = "$wmessage <b>$settings[1]</b>.";
		if(!$pmdisable) { $displayuser .= $userpm = qq~ $rtxt[10] <b>$pmcnt</b> (<b>$new $rtxt[11]</b>) <a href="$surl\lv-memberpanel/a-pm/" title="$rtxt[12]">$rtxt[13]</a>.~; }
			else { $displayuser .= $userpm = " $rtxt[54]"; }
		if($members{'Administrator',$username} && ($maintance || $lockout)) {
			if($maintance) { $on = $rtxt[14]; }
			if($maintance && $lockout) { $on .= $rtxt[15]; }
			if($lockout) { $on .= $rtxt[16]; }
			$displayuser = $userpm .= "<br><b><img src='$images/warning_sm.gif'> $rtxt[17] $on <img src='$images/warning_sm.gif'></b>";
		}
	}

	if($helpdesk) { $help = qq~<a href="$helpdesk" target="_new">$img{'help'}</a>~; $sep = $msp2; }

	$homemenu = qq~<a href="$surl">$img{'home'}</a>~;
	$calmenu = qq~<a href="$surl\lv-cal/">$img{'cal'}</a>~;
	$searchmenu = qq~<a href="$surl\lv-search/~; $searchmenu .= "b-$URL{'b'}/" if($URL{'b'}); $searchmenu .= qq~">$img{'search'}</a>~;
	$menubar = "$homemenu$sep$help$msp2$calmenu$msp2$searchmenu$msp2";

	if($members{'Administrator',$username}) {
		$adminmenu = qq~<a href="$surl\lv-admin/">$img{'admin'}</a>~;
		$menubar .= "$adminmenu$msp2";
	}

	if($username ne 'Guest') {
		$profilemenu = qq~<a href="$surl\lv-memberpanel/">$img{'profile'}</a>~;
		$loginmenu = qq~<a href="$surl\lv-login/p-3/">$img{'logout'}</a>~;
		$menubar .= "$profilemenu$msp2";
	} else {
		$registermenu = qq~<a href="$surl\lv-register/">$img{'register'}</a>~;
		$loginmenu = qq~<a href="$surl\lv-login/">$img{'login'}</a>~;
		$menubar .= "$registermenu$msp2";
	}
	$menubar .= $loginmenu;

	# Get the template
	$footer = '';
	fopen(TEMP,"$templates/$dtheme/template.html") or $ebout .= "Template not found!<br><br>";
	while(<TEMP>) {
		$_ =~ s/<blah v="\$(.+?)">/${$1}/gsi;
		if($_ =~ /eblah.com/) { $Ecopyright = 1; }

		if($_ =~ /(.*?)<blah main>(.*?)\Z/) { $sfoot = 1; $header .= $1; $footer .= $2; next; }
		if(!$sfoot) { $header .= $_; } else { $footer .= $_; }
	}
	fclose(TEMP);
	if($dtheme eq '') { $Ecopyright = 1; }

	$ebout .= $header;

	if(!$Ecopyright && $URL{'v'} ne 'admin') { error('The copyright of this software has been removed! Before you can continue to use this software, add $rights to your template.'); }

	if($username eq 'Guest') {
		$new = '';
		if(!$gdisable) { $ebout .= $guestlogin; }
	}
	$ebout .= $URL{'v'} ne 'memberpanel' && $settings[41] && $new > 0 ? qq~<script language="Javascript1.3">if(window.confirm("$rtxt[59] $new $rtxt[58]")) { location = "$surl\lv-memberpanel/a-pm/"; }</script>~ : '';

	if($md5upgrade && !$settings[46] && $username ne 'Guest') { CoreLoad('Login'); ChangePass(); }
}

sub footer {
	if($uextlog) { ExtClose(); }

	if($settings[1] ne '' && $logactive) {
		@temp = ();
		fopen(FILE,"+<$members/$username.dat"); # Get data into memory again to avoid errors
		@temp = <FILE>;
		chomp @temp;
		truncate(FILE,0);
		seek(FILE,0,0);
		$temp[28] = time;

		($totaltime,$lasttime) = split(/\|/,$temp[45]);
		if($keepon && $lasttime) { $totaltime += (time-$lasttime); }
		$temp[45] = "$totaltime|".time;

		for($q = 0; $q < $usersetcount; $q++) { print FILE "$temp[$q]\n"; }
		fclose(FILE);
	}

	if($debug && $members{'Administrator',$username}) { # Debug, remove in finals
		if($start_debug) { $time_running = sprintf("%.4f",Time::HiRes::time() - $start_debug); }
		$gzipend = $gzipen ? 'Enabled' : 'Disabled';
		$ebout .= qq~<center><br>[ Compile Time: $time_running seconds ] &nbsp; [ $openedfiles files opened ] &nbsp; [ GZIP $gzipend ]</center>~;
		if($debug == 2 || $debug == 4) { sleep(5); }
	}

	$ebout .= $footer;

	if($gzipen) {
		if($gzipen == 2) {
			open(GZIP,"| gzip -f");
			print GZIP $ebout;
			close(GZIP);
		} else {
			require Compress::Zlib;
			binmode STDOUT;
			print Compress::Zlib::memGzip($ebout);
		}
	} else { print $ebout; }
}

sub AL {
	my($buser,$luser,$ltime,@maxlog,$totactive);
	if($username eq 'Guest') {
		if($ENV{'HTTP_USER_AGENT'} =~ /(mediapartners-google|googlebot|inktomi|ask jeeves|lycos|ia_archiver|slurp|msnbot)/i) { $buser = lc($1).'<>'; }
			else { $buser = $ENV{'REMOTE_ADDR'}; }
	} else { $buser = $username; }

	fopen(FILE,"$prefs/Active.txt");
	while(<FILE>) {
		chomp;
		($luser,$ltime) = split(/\|/,$_);
		if(time-$ltime < (60*$activeuserslog)) {
			$fileprint .= "$_\n" if(lc($luser) ne lc($buser));
			$keepon = 1 if(lc($luser) eq lc($buser));
			$activemembers{$luser} = 1; # Keep user in memory for checking online status quickly
		}
		++$totactive;
	}
	fclose(FILE);

	fopen(FILE,"$prefs/MaxLog.txt");
	@maxlog = <FILE>;
	fclose(FILE);
	chomp @maxlog;
	if($maxlog[0] < $totactive) {
		fopen(FILE,">$prefs/MaxLog.txt");
		print FILE "$totactive\n".time;
		fclose(FILE);
	}

	# Check server load ...
	if($serload && !$keepon && $totactive > $serload && !$members{'Administrator',$username}) { return() if $URL{'v'} eq 'login'; error($rtxt[55]); }

	fopen(FILE,"+>$prefs/Active.txt");
	print FILE "$buser|".time."|$settings[18]|$URL{'v'}|$URL{'b'}|$URL{'m'}\n$fileprint";
	fclose(FILE);

	if($uextlog) { $ExtLog[7] = $totactive; }
}

sub error {
	$gdisable = 1;

	my($ecode,$elog,$notfound) = @_;
	my($ttime,$etype,$icon);
	if($ecode eq 'OPEN_ERROR'){ $ecode = $rtxt[56]; }
	$error = Format($ecode);
	$message = $error;
	BC();
	$error = $message;
	if($error =~ /-admin-/ || $error =~ /-register-/) { SpecialErrors(); }
	$icon = 'ban';
	if($elog && $elog < 3) {
		$icon = 'warning';
		if($elog == 2) { $rtxt[18] = $rtxt[51]; $rtxt[19] = "<b>$rtxt[51] $rtxt[41]:</b> $rtxt[53]"; }
		$ewhat = "$rtxt[18] "; $esig = qq~</td></tr><tr><td height="2" class="border"></td></tr><tr><td><span class="smalltext"><img src="$images/warning_sm.gif"> $rtxt[19]</span>~;
		if($kelog) {
			chomp $!; chomp $error; chomp $errorurl;
			$errorurl = "Blah.pl?$ENV{'QUERY_STRING'}";
			$ttime = time;
			$specify = $! || '?';
			fopen(FILE,"+>>$prefs/ELog.txt");
			print FILE "$error|$specify|$ttime|$username|$errorurl\n";
			fclose(FILE);
		}
	}
	$ewhat .= $rtxt[41];
	if($elog == 3) {
		$icon = 'mem_main';
		$ewhat = $boardlock[33];
	}
	$error =~ s/$code|$messages|$members|$prefs|$boards/./gsi;  # Security: Change full paths to local
	$error =~ s/\$rights/&lt;blah v="\$copyright"&gt;/g;
	if($root ne '.') { $error =~ s/$root/./gsi; }
	$title = $ewhat;
	$date_time = get_date(time,1);

	if($notfound) { print "Status: HTTP/1.0 404 Not Found\n"; }

	if($adminsloaded) { headerA(); } else { header(); }
	$ebout .= <<"EOT";
<table class="border" cellpadding="4" cellspacing="1" width="600" align="center">
 <tr>
  <td class="titlebg"><b><img src="$images/$icon.gif"> $title</b></td>
 </tr><tr>
  <td class="win"><span class="smalltext">$rtxt[49]</span></td>
 </tr><tr>
  <td class="win2"><table cellpadding="4" width="100%"><tr><td>$error$esig</td></tr></table></td>
 </tr><tr>
  <td class="win"><table cellpadding="0" width="100%"><tr><td class="smalltext"><b><a href="javascript:history.go(-1)">&#171; $gtxt{'22'}</a></b></td><td align="right" class="smalltext"><a href="mailto:$eadmin">$rtxt[50]</a></td></tr></table></td>
 </tr>
</table>
EOT
	if($adminsloaded) { footerA(); } else { footer(); }
	exit;
}

sub redirect {
	($url2,$noexit) = $_[0];

	if($url eq '') { $url = $surl; }
	if($url2) { $url = $url2; }
	if($redirectfix == 1) { print qq~Content-type: text/html\n\n<html><head><meta http-equiv="refresh" content="0;URL=$url"></head></html>~; } 
	elsif($redirectfix == 2) { print "Refresh: 0;url=$url\n\n"; }
		else { print "Location: $url\n\n"; }
	if(!$noexit) { exit; }
}

sub get_date {
	my($date,$unbld,$personalized,$hourcnt) = @_;
	my($tdate);

	$date = time if($date eq '');

	if($personalized) { ($sec,$min,$hour,$day,$month,$year,$week,$ydays,$dst) = localtime($date); }
		else {
			if($date+3600 > time && !$unbld && $btod) {
				$tdate = int((time-$date)/60);
				if($tdate == 0) { return($rtxt[64]); }
				elsif($tdate == 1) { return($rtxt[63]); }
				elsif($tdate < 60 && $tdate > 0) { return("$tdate $rtxt[62]"); }
			}

			($sec,$min,$hour,$day,$month,$year,$week,$ydays,$dst) = gmtime($date+(3600*($settings[15]+$settings[31]+$gtoff)));
		}

	$curmonth = $month;
	$ampm = 'am';
	$year = 1900 + $year;
	if($min < 10) { $min = "0$min"; }
	if($hour == 12) { $ampm = 'pm'; }
	if($hour == 0) { $hour = 12; }
	if($hour > 12) {
		$hour -= 12;
		$ampm = 'pm';
	}

	date_dis($unbld);
	return($ddis);
}

sub date_dis {
	my($unbld) = $_[0];
	my($ttdate,$tttime,$day1);
	if(!$settings[17]) { $settings[17] = $datedis; }
	if(!$settings[22]) { $settings[22] = $timedis; }
	$day1 = $day;

	if($day < 20 && $day > 10) { $day .= 'th'; }
	elsif($day % 10 == 1) { $day .= 'st'; }
	elsif($day % 10 == 2) { $day .= 'nd'; }
	elsif($day % 10 == 3) { $day .= 'rd'; }
		else { $day .= 'th'; }

	if($settings[17] == 1) { $ttdate = "$days[$week], $months[$month] $day, $year"; }
	elsif($settings[17] == 2) { $ttdate = "$day1 $months[$month] $year"; }
	elsif($settings[17] == 3) { ++$month; $ttdate = "$month.$day1.$year"; }
	elsif($settings[17] == 4) { ++$month; $ttdate = "$day1/$month/$year"; }
	elsif($settings[17] == 5) { ++$month; $ttdate = "$year/$month/$day1"; }
		else { $ttdate = "$months[$month] $day, $year"; }
	if($settings[22] > 1) {
		if($hour < 10) { $hour = "0$hour"; }
		if($ampm eq 'pm' && $hour != 12) { $hour = $hour+12; }
		if($hour == 12 && $ampm eq 'am') { $hour = "00"; }
		if($sec < 10) { $sec = "0$sec"; }
		if($settings[22] == 2) { $tttime = "$hour:$min"; }
			else { $tttime = "$hour:$min:$sec"; }
	} elsif($settings[22] == 1) {
		if($sec < 10) { $sec = "0$sec"; }
		$tttime = "$hour\:$min\:$sec$ampm";
	} else { $tttime = "$hour:$min$ampm"; }
	if(!$unbld && $btod) {
		if($Kday == $day && $Kmonth == $month && $Kyear == $year) { $ttdate = $rtxt[20]; }
		elsif($Yday == $day && $Ymonth == $month && $Yyear == $year) { $ttdate = $rtxt[60]; }
	}

	$ddis = "$ttdate, $tttime";
	if($notime_date) { $ddis = "$months[$month] $day, $year"; }
	$notime_date = 0;
}

sub ClickLog {
	my($clt,$lgtm,$maxtime,$maxed,$final,$rawprint,$nlog);
	if($uextlog) { ++$ExtLog[0]; }

	return() if !$eclick;

	$clt = time;
	$ref = $ENV{'HTTP_REFERER'} =~ /$rurl/ ? '' : $ENV{'HTTP_REFERER'};
	$ref = Format($ref);

	$maxtime = ($logcnt*60);
	$maxx = ($clt-$maxtime);

	fopen(RAWLOG,"+<$prefs/ClickLog.txt");
	while( <RAWLOG> ) {
		chomp;
		($lgtm) = split(/\|/,$_);
		$maxed = ($lgtm-$maxx);
		if($maxed > 0) { $rawprint .= "$_\n"; } else { last; }
	}
	seek(RAWLOG,0,0);
	truncate(RAWLOG,0);
	print RAWLOG "$clt|$ENV{'REMOTE_ADDR'}|$ref|$ENV{'QUERY_STRING'}|$ENV{'HTTP_USER_AGENT'}\n$rawprint";
	fclose(RAWLOG);
}

sub BCSmileys {
	my($smilecnt,$temper);
	if($simages2 ne '') { $temper = $simages; $simages = $simages2; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q::)\E~<img src="$simages/roll.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:)\E~<img src="$simages/smiley.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:-)\E~<img src="$simages/smiley.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:D\E~<img src="$simages/lol.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:-D\E~<img src="$simages/lol.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:B\E~<img src="$simages/blush.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q??)\E~<img src="$simages/huh.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:'(\E~<img src="$simages/cry.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:X\E~<img src="$simages/lipsx.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:o\E~<img src="$simages/shock.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:K)\E~<img src="$simages/kiss.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~(\A|\W);D~$1<img src="$simages/grin.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q;-D\E~<img src="$simages/grin.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q8)\E~<img src="$simages/cool.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:P\E~<img src="$simages/tongue.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q\&gt;:(\E~<img src="$simages/angry.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:-/\E~<img src="$simages/undecided.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:(\E~<img src="$simages/sad.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~\Q:-(\E~<img src="$simages/sad.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~(\A|\W)\Q;)\E~$1<img src="$simages/wink.gif" border="0">~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $message =~ s~(\A|\W)\Q;-)\E~$1<img src="$simages/wink.gif" border="0">~) { ++$smilecnt; }
	if($upbc) {
		if($temper ne '') { $simages = $temper };
		if(!$SmileysOpen) {
			fopen(SMILEY,"$prefs/smiley.txt");
			while($smiley = <SMILEY>) {
				chomp $smiley;
				@t = split(/\|/,$smiley);
				push(@Smilies,$t[0]);
				$Smiley{$t[0]} = $t[1];
			}
			fclose(SMILEY);
			$SmileysOpen = 1;
		}

		foreach(@Smilies) { $message =~ s~\Q$_\E~<img src="$simages/$Smiley{$_}" border="0">~g; }
	}
}

sub Quote {
	my($qdate,$qmessage,$repaste,$qname);
	if($2) {
		$userset{$1}->[1] = '';
		loaduser($1);
		if($userset{$1}->[1] ne '') { $qname = $userurl{$1}; }
			else { $qname = $1; }

		if($3) {
			$qdate = get_date($3);
			$quotedfrom = qq~$rtxt[22] <b>$qname</b>, $rtxt[23] <b>$qdate</b> $rtxt[21] <b><a href="$2" title="$rtxt[25]">$rtxt[26]</a></b>~;
			$qmessage = $4;
		} else { $quotedfrom = qq~$rtxt[22] <b>$qname</b>~; $qmessage = $2; }
	} else {
		$quotedfrom = "<b>$rtxt[27]</b>";
		$qmessage = $1;
	}

	return <<"EOT";
<br>
<table width="95%" class="border" cellpadding="0" cellspacing="1" align="center">
 <tr>
  <td class="postbody"><div class="win3" style="padding: 8px">$quotedfrom</div><div class="win" style="padding: 8px">$qmessage</div></td>
 </tr>
</table>
EOT
}

sub SizedURL {
	my $url;

	$url = $_[1];
	if(length($url) > 100 && $URL{'v'} ne 'print') { $url = substr($url,0,30).'.....'.substr($url,length($url)-20); }
	return(qq~$_[0]<a href="$_[1]" target="_blank">$url</a>~);
}

sub Code {
	if($BCLoad == 0) { return; }

	%translation = (
		'('  => '&#040;',
		'D'  => '&#068;',
		')'  => '&#041;',
		'-'  => '&#045;',
		'/'  => '&#047;',
		':'  => '&#058;',
		'?'  => '&#063;',
		'['  => '&#091;',
		'\\' => '&#092;',
		']'  => '&#093;',
		'.'  => '&#046;'
	);
	$codelander = $1;

	$codelander =~ s/&nbsp; &nbsp; &nbsp;/\t/g; # DO THE TABS
	$codelander =~ s/([\:\(\)\-\/\?\[\]\\\.D])/$translation{$1}/g;
	$height = 25;
	foreach(split(/<br>/,$codelander)) { $height += 10; }
	$codelander =~ s/<br>/\n/g;
	$height = 200 if($height > 200);
	$height = 50  if($height == 35);

	return <<"EOT";
<table class="border" cellpadding="0" cellspacing="1" align="center">
 <tr>
  <td><div class="win3" style="padding: 8px"><b>$rtxt[57]</b></div><div class="win" style="padding: 2px"><p style="overflow: auto; width: 700px; height: $height\lpx; margin: 0px;"><table cellpadding="0" cellspacing="0"><tr><td style="padding: 8px"><pre>$codelander</pre></td></tr></table></p></div></td>
 </tr>
</table>
EOT
}

sub BC {
	if($html && $nosmile < 2) {
		$message =~ s/&quot;/"/g;
		if($htmls[0] ne '') {
			foreach(@htmls) {
				$close = $open = 0;
				while($message =~ s~\&lt;$_(\w? || .*?)\&gt;~<$_$1$2>~) { ++$open; }
				while($message =~ s~\&lt;/$_(.*?)\&gt;~</$_$1>~) { ++$close; }
				while($open > $close) { $message .= "</$_>"; ++$close; } # Close open tags (security)
			}
		} else { $message =~ s~\&lt;(.*?)\&gt;~<$1>~gsi; }
	}
	$message =~ s~\[code\](.+?)\[/code\]~&Code~esgi;

	$message =~ s~\[quote by=(.+?) link=(.+?) date=(.+?)\](.+?)\[/quote\]~&Quote~gsie;
	$message =~ s~\[quote=(.+?)\](.+?)\[/quote\]~&Quote~gsie;
	$message =~ s~\[quote\](.+?)\[/quote\]~&Quote~gsie;

	if($al) {
		$message =~ s~([^\w\"\=\[\]]|[\n\b]|\A)\\*(\w+://[\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%,.]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%])~SizedURL($1,$2)~eisg;
		$message =~ s~([^\"\=\[\]/\:\.(\://\w+)]|[\n\b]|\A|[\<\n\b\>])\\*(www\.[^\.][\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%\,]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%])~SizedURL($1,"http://$2")~eisg;
	}
	if($BCSmile && ($nosmile != 1 && $nosmile != 3)) { BCSmileys(); }

	if(!$BCLoad) { $message = CensorList($message); return(); } # BC is disabled

	$message =~ s~\[s\](.*?)\[/s\]~<s>$1</s>~gsi;
	$message =~ s~\[b\](.+?)\[/b\]~<b>$1</b>~gsi;
	$message =~ s~\[i\](.*?)\[/i\]~<i>$1</i>~gsi;
	$message =~ s~\[u\](.*?)\[/u\]~<u>$1</u>~gsi;
	$message =~ s~\[blockquote\](.*?)\[/blockquote\]~<blockquote>$1</blockquote>~gsi;
	$message =~ s~\[size=([1-9][^\s\n<>]*?)\](.*?)\[/size\]~<font size="$1" style="line-height: normal">$2</font>~gsi;

	$message =~ s~\[img\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/img\]~<img src="$1://$2" border="0">~gsi;
	$message =~ s~\[img width=([1-9][^\s]*?) height=([1-9][^\s]*?)\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/img\]~<img src="$3://$4" width="$1" height="$2" border="0">~gsi;
	$message =~ s~\[img width=([1-9][^\s]*?) height=([1-9][^\s]*?) align=(right|left)\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/img\]~<img src="$4://$5" width="$1" height="$2" border="0" style="float:$3" align="float:$3">~gsi;
	$message =~ s~\[img align=(right|left)\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/img\]~<img src="$2://$3" border="0" style="float:$1" align="float:$1">~gsi;

	$message =~ s~\[url=(http|ftp|mms|https)://(.[^\s\n<>]+?)\](.+?)\[/url\]~<a href="$1://$2" title="$2" target="_new">$3</a>~gsi;
	$message =~ s~\[url=www\.(.[^\s\n<>]+?)\](.+?)\[/url\]~<a href="http://www.$1" title="www.$1" target="_new">$2</a>~gsi;
	$message =~ s~\[url\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/url\]~SizedURL('',"$1://$2")~egsi;
	$message =~ s~\[url\]www\.(.[^\s\n<>]+?)\[/url\]~SizedURL('',"http://www.$1")~egsi;

	$message =~ s~\[flash width=([0-9]*?) height=([0-9]*?) url=(http|ftp|mms|https)://(.[^\s\n<>]+?)\]~<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="$1" height="$2"><param name="movie" value="$3://$4"><param name="play" value="true"><param name="loop" value="true"><param name="quality" value="high"><embed src="$3://$4" width="$1" height="$2" play="true" loop="true" quality="high"></embed></object>~gsi;

	$message =~ s~\[pre\](.+?)\[/pre\]~<pre>$1</pre>~gsi;
	if($message =~ /\[list(.*?)\](.*?)\[\/list\]/) {
		$message =~ s~\[list\](.+?)\[/list\]~<ul>$1</ul>~gsi;
		$message =~ s~\[list=([a-zA-Z|1]+?)\](.+?)\[/list\]~<ol type="$1">$2</ol>~gsi;
		$message =~ s~\[\*\]~<li>~gsi;
	}

	$message =~ s~\[left\](.+?)\[/left\]~<div align="left">$1</div>~gsi;
	$message =~ s~\[right\](.+?)\[/right\]~<div align="right">$1</div>~gsi;
	$message =~ s~\[center\](.+?)\[/center\]~<center>$1</center>~gsi;
	$message =~ s~\[justify\](.+?)\[/justify\]~<div align="justify">$1</div>~gsi;
	$message =~ s~\[face=(.+?)\](.+?)\[/face\]~<font face="$1">$2</font>~gsi;
	$message =~ s~\[color=(.+?)\](.+?)\[/color\]~<font color="$1">$2</font>~gsi;

	$message =~ s~\[glow=(.+?) strength=(.+?)\](.*?)\[/glow\]~<span style="filter:glow(color=$1, strength=$2);height: 1px;">$3</span>~gsi;
	$message =~ s~\[glow=(.+?)\](.*?)\[/glow\]~<span style="filter:glow(color=$1, strength=5);height: 1px;">$2</span>~gsi;
	$message =~ s~\[shadow=(.+?) strength=(.+?)\](.*?)\[/shadow\]~<span style="filter:shadow(color=$1, strength=$2);height: 1px;">$3</span>~gsi;
	$message =~ s~\[shadow=(.+?)\](.*?)\[/shadow\]~<span style="filter:shadow(color=$1, strength=5);height: 1px;">$2</span>~gsi;

	$message =~ s~\[hr\]~<hr size="1" width="100%" color="$color{'border'}">~gsi;
	$message =~ s~\[sub\](.+?)\[/sub\]~<sub>$1</sub>~gsi;
	$message =~ s~\[sup\](.+?)\[/sup\]~<sup>$1</sup>~gsi;
	$message =~ s~\[mail\](.+?)\[/mail\]~<a href="mailto:$1">$1</a>~gsi;
	$message =~ s~\[mail=(.+?)\](.+?)\[/mail\]~<a href="mailto:$1">$2</a>~gsi;
	$message =~ s~\[move\](.+?)\[/move\]~<marquee>$1</marquee>~gsi;

	if($message =~ /\[table\](.+?)\[\/table\]/) {
		$message =~ s/<br>/\t/gsi;
		while($message =~ s~\t{0,1}\[table\]\t{0,1}(.+?)\t{0,1}\[\/table\]\t{0,1}~<table>$1</table>~sgi) {
			while($message =~ s~<table>\t{0,1}(.*?)\t{0,1}\[tr\]\t{0,1}(.*?)\t{0,1}\[/tr\]\t{0,1}(.*?)\t{0,1}</table>~<table>$1<tr>$2</tr>$3</table>~sgi) { } # Loop until rows are done.
			while($message =~ s~<table>(.*?)<tr>\t{0,1}(.*?)\t{0,1}\[td\]\t{0,1}(.*?)\t{0,1}\[/td\]\t{0,1}(.*?)\t{0,1}</tr>(.*?)</table>~<table>$1<tr>$2<td>$3</td>$4</tr>$5</table>~sig) { } # Loop until cols are done.
		}
		$message =~ s/\t/<br>/gsi;
	}
	$message = CensorList($message);
}

sub smail {
	my($subject,$message,$wholemessage,$tothis);
	my($to,$subject,$message,$from) = @_;
	if(!$to || !$subject || !$message) { return(-1); }
	if($to !~ /\A([0-9A-Za-z\._\-]{1,})@([0-9A-Za-z\._\-]{1,})+\.([0-9A-Za-z\._\-]{1,})+\Z/) { return(-1); }

	$message =~ s/\cM//g;
	$message =~ s/\n/<br>/gsi;
	$message =~ s/  /&nbsp; /gsi;
	$message =~ s/&lt;br&gt;/<br>/gsi;
	$message =~ s/<br>/<br>\n/gsi;
	$message =~ s/bgcolor="(.+?)"/bgcolor="#FFFFFF"/gsi;
	$emailsig = Unformat($emailsig);
	if($emailsig) { $message .= qq~<br><br><hr size="1" color="#C0C0C0">$emailsig~; }

	$wholemessage = <<"EOT";
<html>
<body bgcolor="#FFFFFF">
<font face="Verdana,Arial" color="#000000" size="2">$message</font>
</body>
</html>
EOT
	if($settings[2] ne '' && $from eq '') { $eadmin = $settings[2]; }
	if($from eq '') { $from = $regto; }
	if($eadmin eq '') { $eadmin = "noreply\@noreply.noreply"; }
	if($mailuse == 1) {
		open(MAIL,"| $smaill -t");
		print MAIL "MIME-Version: 1.0\n";
		print MAIL "Content-Type: text/html; charset=\"ISO-8859-1\"\n";
		print MAIL "Content-Transfer-Encoding: 7bit\n";
		print MAIL "X-Forum-System: e-blah, $version, copyright 2001-2003\n";
		print MAIL "X-Username: $username\n";
		print MAIL "X-Sent-From-IP: $ENV{'REMOTE_ADDR'}\n";
		print MAIL "To: $to\n";
		print MAIL "From: \"$regto\" <$eadmin>\n";
		print MAIL "Subject: $subject\n\n";
		print MAIL "$wholemessage";
		print MAIL "\n\n";
		close(MAIL);
	} elsif($mailuse == 2) {
		eval q{
			use Net::SMTP;
			my $smtp = Net::SMTP->new($mailhost);
			if($mailauth) { $smtp->auth($mailusername,$mailpassword); }
			$smtp->mail($eadmin);
			$smtp->to($to);
			$smtp->data();
			$smtp->datasend("MIME-Version: 1.0\n");
			$smtp->datasend("Content-Type: text/html; charset=ISO-8859-1\n");
			$smtp->datasend("Content-Transfer-Encoding: 7bit\n");
			$smtp->datasend("X-Forum-System: e-blah, $version, copyright 2001-2003\n");
			$smtp->datasend("X-Username: $username\n");
			$smtp->datasend("X-Sent-From-IP: $ENV{'REMOTE_ADDR'}\n");
			$smtp->datasend("To: $to\n");
			$smtp->datasend("From: \"$regto\" <$eadmin>\n");
			$smtp->datasend("Subject: $subject\n\n");
			$smtp->datasend("$wholemessage");
			$smtp->datasend("\n");
			$smtp->dataend();
			$smtp->quit;
		};
		if($@) { error("[b]Net::SMTP Error[/b]\n\n$@",2); }
	}

	$maildebug = 0; # Debugging is so lame ... but gotta do it to make stuff work!  =(
	if($maildebug) {
		$time = time;
		fopen(OPENFILE,">$code/$time\_mailed.txt");
		print OPENFILE "To: $to\nFrom: \"$from\" <$eadmin>\nSubject: $subject\n\n$wholemessage";
		fclose(OPENFILE);
	}

	return(1); # Clean return
}

sub ExtClose { # Save extensive log ..
	my($save,$u,$day,$month,$year);

	($t,$t,$t,$day,$month,$year) = localtime(time);
	$save = $day.$month.$year;

	fopen(WRITEEXT,"+<$prefs/BHits/$save.txt");
	@ExtensiveLogs = <WRITEEXT>;
	chomp @ExtensiveLogs;
	if($ExtensiveLogs[0] eq '') {
		fclose(WRITEEXT);
		fopen(WRITEEXT,"+>$prefs/BHits/$save.txt");
	}
	seek(WRITEEXT,0,0);
	truncate(WRITEEXT,0);
	for($u = 0; $u < @ExtensiveLogs; $u++) {
		if($ExtensiveLogs[$u] eq '') { $ExtensiveLogs[$u] = 0; }
		if($u != 7) { $PLog[$u] = ($ExtLog[$u]+$ExtensiveLogs[$u]) || 0; }
	}
	if($ExtensiveLogs[7] < $ExtLog[7]) { $PLog[7] = $ExtLog[7]; } else { $PLog[7] = $ExtensiveLogs[7]; }
	print WRITEEXT "$PLog[0]\n$PLog[1]\n$PLog[2]\n$PLog[3]\n$PLog[4]\n$PLog[5]\n".time."\n$PLog[7]";
	fclose(WRITEEXT);
}

sub Mark {
	if($username eq 'Guest') { error("$rtxt[28]-register-"); }
	if($URL{'l'} eq 'bindex') { $l = "AllBoards"; }
	if($URL{'l'} eq 'bdis')   {
		$l = "AllRead_$URL{'b'}"; $url = $surl;

		fopen(FILE,"$boards/$URL{'b'}.msg");
		while(<FILE>) {
			($t) = split(/\|/,$_);
			$del{$t} = 1;
		}
		fclose(FILE);
	}

	fopen(FILE,"$members/$username.log");
	while(<FILE>) {
		chomp;
		($t) = split(/\|/,$_);
		if($del{$t} || $t eq $l || $URL{'b'} eq $t) { next; }
		$markdata .= "$_\n";
	}
	fclose(FILE);

	if($URL{'b'} ne '') { $markdata .= "$URL{'b'}|".time."\n"; }

	fopen(FILE,">$members/$username.log");
	print FILE "$l|".time."\n$markdata";
	fclose(FILE);

	redirect();
}

sub MakeComma {
	$ctobe = $_[0];
	if(!$nocomma) { return($ctobe); }
	if(!$ctobe) { return(0); }
	while($ctobe =~ s/^([-+]?\d+)(\d{3})/$1$nocomma$2/) { } # Loop and make commas
	return($ctobe);
}

sub SpecialErrors {
	$loginout = $username ne 'Guest' ? "\lv-memberpanel/a-view/u-" : "\lv-login/u-";

	if($error =~ s/(-admin-|-register-)//) {
		if($1 eq '-register-') { $reg = 1; }
	}

	for($x = 1; $x < 3; ++$x) {
		$tryuser = $Blah{"$cookpre\_Logout$x"};
		if($tryuser) {
			loaduser($tryuser);
			if($members{'Administrator',$tryuser}) { $adminerror .= qq~<a href="$surl$loginout$tryuser/">$userset{$tryuser}->[1]</a><br>~; }
			if($userset{$tryuser}->[1] ne '') { $addreg .= qq~<a href="$surl$loginout$tryuser/">$rtxt[29] $userset{$tryuser}->[1]</a><br>~; }
		}
	}
	$adminerror =~ s/<br>\Z//;
	$addreg =~ s/<br>\Z//;
	if($adminerror && !$reg) { $error .= qq~<br><br><span class="smalltext"><b>$rtxt[30]:</b><br>$adminerror</span>~; }
	if($reg) {
		if($addreg) { $addreg = qq~<br><br><b>$rtxt[30]:</b><br>$addreg~; }
		$error .= qq~<br><br><span class="smalltext"><b>$rtxt[32]:</b><br><a href="$surl\lv-register/">$rtxt[33]</a>.<br><a href="$surl\lv-login/">$rtxt[34]</a>.$addreg</span>~;
	}

	print "Status: HTTP/1.0 403 Forbidden\n";
}

sub ShowGuest {
	CoreLoad('Login',1);

	$guestlogin = <<"EOT";
<table cellpadding="4" cellspacing="1" class="border" width="450" align="center">
 <tr>
  <td class="titlebg"><span class="smalltext"><b>$rtxt[35]</b></span></td>
 </tr><tr><form action="$surl\lv-login/p-2/" method="POST">
  <td class="win">
   <table cellpadding="2" cellspacing="0" width="100%">
    <tr>
     <td><span class="smalltext"><b>$rtxt[36]:</b></span></td>
     <td colspan="2"><input type="text" class="textinput" name="username" size="20" tabindex="56"></td>
     <td><span class="smalltext"><b><a href="$surl\lv-register/">$logintxt[3]</a></b></span></td>
    </tr><tr>
     <td><span class="smalltext"><b>$rtxt[37]:</b></span></td>
     <td><input type="password" class="textinput" name="password" size="20" tabindex="57"></td>
     <td>&nbsp; &nbsp;<input type="hidden" name="days" value="forever"><input type="hidden" name="redirect" value="$ENV{'QUERY_STRING'}"><input type="submit" class="button" value="&nbsp;&nbsp;$rtxt[38]&nbsp;&nbsp;" tabindex="58"></td>
     <td><span class="smalltext"><b><a href="$surl\lv-login/p-forgotpw/">$logintxt[5]</a></b></span></td>
    </tr>
   </table>
  </td>
 </form></tr>
</table><br>
EOT
}

sub calage {
	($bday) = @_;
	($t,$t,$t,$td,$tm,$ty) = localtime(time);
	($m,$d,$y) = split("/",$bday);
	$ty += 1900;
	if($y < 1900) { $y += 1900; }
	$age = ($ty-$y)-1;
	if((($tm+1) == $m && $td >= $d) || ($tm+1) > $m) { ++$age; }
	if(!$bday) { $age = 0; } else { --$m; $ageurl = "$surl\lv-cal/month-".($m+1)."/"; }
	return($age);
}

sub CheckDays {
	($qmon) = $_[0];
	$number = (int($qyear/4)*4);
	if($qmon eq 0 || $qmon eq 2 || $qmon eq 4 || $qmon eq 6 || $qmon eq 7 || $qmon eq 9 || $qmon eq 11) { $days = 31; }
	elsif($qmon eq 3 || $qmon eq 5 || $qmon eq 8 || $qmon eq 10) { $days = 30; }
	elsif($qmon eq 1) { $days = $qyear == $number ? 29 : 28; }
	return($days);
}

sub Highlight {
	$_[0] =~ s/<br>/<br>\n/gsi;
	@smallm = split(/(<.+?>)\s/,$_[0]);
	$_[0] = '';

	foreach(@smallm) {
		if($_ !~ /[ht|f]tp/ && $_ !~ /<(.*?)>/) {
			foreach $hl (@lights) {
				if($hl eq '') { next; }
				$_ =~ s~(\Q$hl\E)~<span style="background-color:yellow; color: black; font-weight: bold;">$1</span>~isg;
			}
		}
		$_[0] .= "$_ ";
	}
}

sub VerifyBoard { # This simply verifies that the user requesting, has authorization to get the data requested
	my($id,$nme,$grps,$input,$memgrp,$catbase,@binfo,$grp);

	foreach $catbase (@catbase) {
		($nme,$id,$grps,$input) = split(/\|/,$catbase);

		if($grps ne '') {
			$con = '';
			$con = 1 if(GetMemberAccess($grps));
			if(!$con) { next; }
		}
		@input2 = split("/",$input);
		foreach $onlist (@input2) {
			$boardson{$onlist} = 1;
		}

		$catallow{$id} = 1;
		++$catcounter;
	}

	foreach $boardindex (@boardbase) {
		($id2,$t,$t,$t,$t,$t,$t,$binfo[6],$t,$t,$binfo[9]) = split("/",$boardindex);

		if(!$boardson{$id2}) { next; }
		if($binfo[6] ne '') { next; }

		$con = '';
		$con = 1 if(GetMemberAccess($binfo[9]));
		if(!$con) { next; }

		$boardallow{$id2} = 1;
		++$boardcounter;
	} # Command outputs: $[cat|board]allow{id} and $[cat|board]counter
}

sub SetCookie { # Gets cookie data, and prints it
	my($cookname,$cookvalue,$cookexp) = @_;
	my($cookprint);

	print "Set-Cookie: $cookname=$cookvalue; path=/; expires=$cookexp\n";
	return(1);
}

sub NotifyAddStatus {
	if($username eq 'Guest') { return(0); }

	my($message,$status,$add) = @_; # 1 = Add/Rem; 2 = Certain Message Status; 3 = Users on 1 message; 4 = Return the full db
	my($messageid,$userbase,$baseuser,$newbase,$indb);

	if(!$maildbopen) {
		fopen(DB,"$messages/Mail/database.mail");
		@maildatabase = <DB>;
		fclose(DB);
		chomp @maildatabase;
		$maildbopen = 1;
	}

	return(1) if $status == 4;

	fopen(DB,">$messages/Mail/database.mail") if ($status == 1);
	foreach(@maildatabase) {
		($messageid,$userbase) = split(/\|/,$_);
		@userbase = split(",",$userbase);

		if($messageid eq $message) {
			return(@userbase) if $status == 3;

			foreach $baseuser (@userbase) {
				if($username eq $baseuser) {
					return(1) if $status == 2;
					next;
				}
				$newbase .= "$baseuser,";
			}
			$newbase .= "$username" if $add;
			$newbase =~ s/,\Z//g;
			$indb = 1;
		}

		if($status == 1) {
			print DB "$messageid|$newbase\n" if ($messageid eq $message && $newbase ne '');
			print DB "$messageid|$userbase\n" if ($messageid ne $message);
		}
	}
	print DB "$message|$username\n" if ($status == 1 && !$indb && $add);
	fclose(DB) if ($status == 1);

	$maildbopen = 0 if $status == 1; # We've got to reload the DB ...

	return(0) if $status == 2;
}

sub UserDatabase {
	if(!$mlistload) {
		fopen(FILE,"$members/List2.txt");
		@memlist2 = <FILE>;
		fclose(FILE);
		chomp @memlist2;
		$mlistload = 1;
	}

	if($_[0] eq '') { return(); }

	fopen(FILE,">$members/List2.txt");
	foreach(@memlist2) {
		@t = split(/\|/,$_);
		if($t[0] eq $_[0]) { print FILE "$_[0]|$_[1]|$_[2]|$_[3]|$_[4]|$_[5]|$_[6]\n"; }
			else { print FILE "$t[0]|$t[1]|$t[2]|$t[3]|$t[4]|$t[5]|$t[6]\n"; }
	}
	fclose(FILE);
}

sub CheckTime {
	print "Content-type: text/html\n\n";
	$URL{'zone'} =~ s/\'/\-/g;
	$settings[15] = $URL{'zone'};
	$settings[31] = 1 if($URL{'saving'} eq 'true');
	$settings[17] = $URL{'date'};
	$settings[22] = $URL{'time'};
	print get_date(time,1);
	exit;
}
1;